<?php
//K-Detection v2.1

if (!defined('SMF'))
	die('Hacking attempt...');
	
function K_Detection($user_agent)
{
    $k_detected = array(
    'os' => "",
    'os_ico' => "unknown",
    'br' => "",
    'br_ico' => "unknown"
    );
    $tmp_array = array();

    // 
    // Check browsers
    // 
        
    // SeaMonkey
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*seamonkey\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "SeaMonkey" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'seamonkey';
      }
  
    // Camino
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*camino\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Camino" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'camino';
      }

    // Netscape
    if(preg_match('/mozilla.*netscape[0-9]?\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Netscape" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'netscape';
      }

    // Epiphany
    if(preg_match('/mozilla.*gecko\/[0-9]+.*epiphany\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Epiphany" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'epiphany';
      }

    // Galeon
    if(preg_match('/mozilla.*gecko\/[0-9]+.*galeon\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Galeon" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'galeon';
      }

    // Flock
    if(preg_match('/mozilla.*gecko\/[0-9]+.*flock\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Flock" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'flock';
      }

    // Minimo
    if(preg_match('/mozilla.*gecko\/[0-9]+.*minimo\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Minimo" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'mozilla';
      }

    // K-Meleon
    if(preg_match('/mozilla.*gecko\/[0-9]+.*k\-meleon\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "K-Meleon" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'k-meleon';
      }

    // K-Ninja
    if(preg_match('/mozilla.*gecko\/[0-9]+.*k-ninja\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "K-Ninja" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'k-ninja';
      }

    // Kazehakase
    if(preg_match('/mozilla.*gecko\/[0-9]+.*kazehakase\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Kazehakase" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'kazehakase';
      }

    // Firefox
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*firefox\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Firefox" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'firefox';
      }

    // Bon Echo
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*BonEcho\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Bon Echo" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'deerpark';
      }

    // Minefield
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*Minefield\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Minefield" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'minefield';
      }

    // Firebird
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*firebird\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Firebird" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'phoenix';
      }

    // Phoenix
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*phoenix\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Phoenix" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'phoenix';
      }

    // Mozilla Suite
    if(preg_match('/mozilla.*rv:([0-9\.]+).*gecko\/[0-9]+.*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Mozilla";
      $k_detected['br_ico'] = 'mozilla';
    // Last official version was 1.7.13, drop all versions where second number > 7
    if((int)substr($tmp_array[1],2,1) <= 7)
      {
      $k_detected['br'] .= ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }
    else
      {
      $k_detected['br'] .= " compatible";
      }
    }

    // Konqueror
    if(preg_match('/mozilla.*konqueror\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Konqueror" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'konqueror';
      if(preg_match('/khtml\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array))
        {
        $k_detected['br'] = "Konqueror" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Opera
    if((preg_match('/mozilla.*opera ([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) || preg_match('/^opera\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array)) && !$k_detected['br'])
      {
      $k_detected['br'] = "Opera" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'opera';
      if(preg_match('/opera mini/si', $user_agent))
        {
        preg_match('/opera mini\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array);
        $k_detected['br'] .= " (Opera Mini" . ($tmp_array[1] ? " ".$tmp_array[1] : "") . ")";
        }
    }

    // OmniWeb
    if(preg_match('/mozilla.*applewebkit\/[0-9]+.*omniweb\/v[0-9\.]+/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "OmniWeb";
      $k_detected['br_ico'] = 'omniweb';
      }

    // SunriseBrowser
    if(preg_match('/mozilla.*applewebkit\/[0-9]+.*sunrisebrowser\/([0-9a-z\+\-\.]+)/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "SunriseBrowser" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'sunrise';
      }

    // DeskBrowse
    if(preg_match('/mozilla.*applewebkit\/[0-9]+.*deskbrowse\/([0-9a-z\+\-\.]+)/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "DeskBrowse" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'deskbrowse';
      }

    // Shiira
    if(preg_match('/mozilla.*applewebkit.*shiira\/([0-9a-z\+\-\.]+).*safari/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Shiira" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'shiira';
      }

    // Safari
    if(preg_match('/mozilla.*applewebkit.*safari\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Safari";
      $k_detected['br_ico'] = 'safari';

      // Translate Safari build into version number
	  if(substr($tmp_array[1], 0, 3) == "521")
        {
        $k_detected['br'] .= " 3.0";
        }
      elseif(substr($tmp_array[1], 0, 3) == "419")
        {
        $k_detected['br'] .= " 2.0.4";
        }
      elseif(substr($tmp_array[1], 0, 3) == "417")
        {
        $k_detected['br'] .= " 2.0.3";
        }
      elseif(substr($tmp_array[1], 0, 3) == "416")
        {
        $k_detected['br'] .= " 2.0.2";
        }
      elseif($tmp_array[1] == "412.5")
        {
        $k_detected['br'] .= " 2.0.1";
        }
      elseif(substr($tmp_array[1], 0, 3) == "412")
        {
        $k_detected['br'] .= " 2.0";
        }
      elseif($tmp_array[1] == "312.6" || $tmp_array[1] == "312.5")
        {
        $k_detected['br'] .= " 1.3.2";
        }
      elseif(substr($tmp_array[1], 0, 5) == "312.3")
        {
        $k_detected['br'] .= " 1.3.1";
        }
      elseif(substr($tmp_array[1], 0, 3) == "312")
        {
        $k_detected['br'] .= " 1.3";
        }
      elseif($tmp_array[1] == "125.12" || $tmp_array[1] == "125.11")
        {
        $k_detected['br'] .= " 1.2.4";
        }
      elseif($tmp_array[1] == "125.9")
        {
        $k_detected['br'] .= " 1.2.3";
        }
      elseif($tmp_array[1] == "125.8" || $tmp_array[1] == "125.7")
        {
        $k_detected['br'] .= " 1.2.2";
        }
      elseif($tmp_array[1] == "125.1")
        {
        $k_detected['br'] .= " 1.2.1";
        }
      elseif(substr($tmp_array[1], 0, 3) == "125")
        {
        $k_detected['br'] .= " 1.2";
        }
      elseif($tmp_array[1] == "101.1")
        {
        $k_detected['br'] .= " 1.1.1";
        }
      elseif(substr($tmp_array[1], 0, 3) == "100")
        {
        $k_detected['br'] .= " 1.1";
        }
      elseif(substr($tmp_array[1], 0, 4) == "85.8")
        {
        $k_detected['br'] .= " 1.0.3";
        }
      elseif($tmp_array[1] == "85.7")
        {
        $k_detected['br'] .= " 1.0.2";
        }
      elseif(substr($tmp_array[1], 0, 2) == "85")
        {
        $k_detected['br'] .= " 1.0";
        }
      elseif(substr($tmp_array[1], 0, 2) == "74")
        {
        $k_detected['br'] .= " 1.0b2";
        }
      elseif(substr($tmp_array[1], 0, 2) == "73")
        {
        $k_detected['br'] .= " 0.9";
        }
      elseif(substr($tmp_array[1], 0, 2) == "60")
        {
        $k_detected['br'] .= " 0.8.2";
        }
      elseif(substr($tmp_array[1], 0, 2) == "51")
        {
        $k_detected['br'] .= " 0.8.1";
        }
      elseif(substr($tmp_array[1], 0, 2) == "48")
        {
        $k_detected['br'] .= " 0.8";
        }
      }
  
    // Dillo
    if(preg_match('/dillo\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Dillo" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'dillo';
      }

    // iCab
    if(preg_match('/icab\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "iCab" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'icab';
      }

    // Lynx
    if(preg_match('/^lynx\/([0-9a-z\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Lynx" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'lynx';
      }

    // Links
    if(preg_match('/^links \(([0-9a-z\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Links" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'links';
      }

    // Elinks
    if(preg_match('/^elinks \(([0-9a-z\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "ELinks" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'links';
      }
    if(preg_match('/^elinks\/([0-9a-z\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "ELinks" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'links';
      }
    if(preg_match('/^elinks$/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "ELinks";
      $k_detected['br_ico'] = 'links';
      }

    // Wget
    if(preg_match('/^Wget\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Wget" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'wget';
      }

    // Amiga Aweb
    if(preg_match('/Amiga\-Aweb\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Amiga Aweb" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'aweb';
      }

    // Amiga Voyager
    if(preg_match('/AmigaVoyager\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Amiga Voyager" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'voyager';
      }

    // IBrowse
    if(preg_match('/IBrowse\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "IBrowse" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'ibrowse';
      }

    // Openwave
    if(preg_match('/UP\.Browser\/([0-9a-zA-Z\.]+).*/s', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Openwave" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'openwave';
      }
    if(preg_match('/UP\/([0-9a-zA-Z\.]+).*/s', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Openwave" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'openwave';
      }

    // NetFront
    if(preg_match('/NetFront\/([0-9a-z\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "NetFront" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'netfront';
      }

    // PlayStation Portable
    if(preg_match('/psp.*playstation.*portable[^0-9]*([0-9a-z\.]+)\)/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "PSP" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'playstation';
      }

    // Various robots...

    // Googlebot
    if(preg_match('/Googlebot\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Googlebot" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'robot';
      }

    // Googlebot Image
    if(preg_match('/Googlebot\-Image\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Googlebot Image " . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'robot';
      }

    // Gigabot
    if(preg_match('/Gigabot\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Gigabot" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'robot';
      }

    // W3C Validator
    if(preg_match('/^W3C_Validator\/([0-9a-z\+\-\.]+)$/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "W3C Validator" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'robot';
      }

    // W3C CSS Validator
    if(preg_match('/W3C_CSS_Validator_[a-z]+\/([0-9a-z\+\-\.]+)$/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "W3C CSS Validator" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'robot';
      }

    // MSN Bot
    if(preg_match('/msnbot\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "MSNBot" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'robot';
      }

    // cfetch/voyager
    if(preg_match('/^(cfetch|voyager)\/([0-9a-z\+\-\.]+)$/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "voyager" . ($tmp_array[2] ? " ".$tmp_array[2] : "");
      $k_detected['br_ico'] = 'robot';
      }

    // BecomeBot
    if(preg_match('/BecomeBot\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "BecomeBot" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'robot';
      }

    // Alexa
    if(preg_match('/^ia_archiver$/si', $user_agent) && !$k_detected['br'])
      {
      $k_detected['br'] = "Alexa";
      $k_detected['br_ico'] = 'robot';
      }

    // Inktomi Slurp
    if(preg_match('/slurp.*inktomi/si', $user_agent) && !$k_detected['br'])
      {
      $k_detected['br'] = "Inktomi Slurp";
      $k_detected['br_ico'] = 'robot';
      }

    // Yahoo Slurp
    if(preg_match('/yahoo!.*slurp/si', $user_agent) && !$k_detected['br'])
      {
      $k_detected['br'] = "Yahoo! Slurp";
      $k_detected['br_ico'] = 'robot';
      }

    // end of robots

    // MSIE
    if(preg_match('/microsoft.*internet.*explorer/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Microsoft Internet Explorer 1.0";
      $k_detected['br_ico'] = 'msie';
      }
    if(preg_match('/mozilla.*MSIE ([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Microsoft Internet Explorer" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'msie';
      }

    // Netscape Navigator
    if(preg_match('/Mozilla\/([0-4][0-9\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Netscape Navigator" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['br_ico'] = 'netscape_old';
      }

    // Catchall for other Mozilla compatible browsers
    if(preg_match('/mozilla/si', $user_agent, $tmp_array) && !$k_detected['br'])
      {
      $k_detected['br'] = "Mozilla compatible";
      $k_detected['br_ico'] = 'mozilla';
      }

    // 
    // Check system
    // 

    // Linux
    if(preg_match('/linux/si', $user_agent) && !$k_detected['os'])
      {
      $k_detected['os'] = "Linux";
      $k_detected['os_ico'] = "linux";
      if(preg_match('/gentoo/si', $user_agent))
        {
        $k_detected['os'] .= " (Gentoo)";
        $k_detected['os_ico'] = "gentoo";
        }
      elseif(preg_match('/debian/si', $user_agent))
        {
        $k_detected['os'] .= " (Debian)";
        $k_detected['os_ico'] = "debian";
        }
      elseif(preg_match('/fedora/si', $user_agent))
        {
        $k_detected['os'] .= " (Fedora)";
        $k_detected['os_ico'] = "fedora";
        }
      elseif(preg_match('/ubuntu/si', $user_agent))
        {
        $k_detected['os'] .= " (Ubuntu)";
        $k_detected['os_ico'] = "ubuntu";
        }
      elseif(preg_match('/redhat/si', $user_agent))
        {
        $k_detected['os'] .= " (Redhat)";
        $k_detected['os_ico'] = "redhat";
        }
      elseif(preg_match('/slackware/si', $user_agent))
        {
        $k_detected['os'] .= " (Slackware)";
        $k_detected['os_ico'] = "slackware";
        }
      elseif(preg_match('/mdk/si', $user_agent))
        {
        $k_detected['os'] .= " (Mandrake)";
        $k_detected['os_ico'] = "mandrake";
        }
      elseif(preg_match('/kanotix/si', $user_agent))
        {
        $k_detected['os'] .= " (Kanotix)";
        $k_detected['os_ico'] = "kanotix";
        }
      elseif(preg_match('/suse/si', $user_agent))
        {
        $k_detected['os'] .= " (Suse)";
        $k_detected['os_ico'] = "suse";
        }
      elseif(preg_match('/lycoris/si', $user_agent))
        {
        $k_detected['os'] .= " (Lycoris)";
        $k_detected['os_ico'] = "lycoris";
        }
      elseif(preg_match('/knoppix/si', $user_agent))
        {
        $k_detected['os'] .= " (Knoppix)";
        $k_detected['os_ico'] = "knoppix";
        }
      elseif(preg_match('/centos/si', $user_agent))
        {
        $k_detected['os'] .= " (CentOS)";
        $k_detected['os_ico'] = "centos";
        }
      }

    // BSD
    if(preg_match('/bsd/si', $user_agent) && !$k_detected['os'])
      {
      $k_detected['os'] = "BSD";
      $k_detected['os_ico'] = "bsd";
      if(preg_match('/freebsd/si', $user_agent))
        {
        $k_detected['os'] = "FreeBSD";
        }
      elseif(preg_match('/openbsd/si', $user_agent))
        {
        $k_detected['os'] = "OpenBSD";
        }
      elseif(preg_match('/netbsd/si', $user_agent))
        {
        $k_detected['os'] = "NetBSD";
        }
      }

    // Mac OS (X)
    if((preg_match('/mac_/si', $user_agent) || preg_match('/macos/si', $user_agent) || preg_match('/powerpc/si', $user_agent) || preg_match('/mac os/si', $user_agent) || preg_match('/68k/si', $user_agent) || preg_match('/macintosh/si', $user_agent)) && !$k_detected['os'])
    {
      $k_detected['os'] = "Mac OS";
      $k_detected['os_ico'] = "macos";
      if(preg_match('/mac os x/si', $user_agent))
        {
        $k_detected['os'] .= " X";

        // if browser == safari try to detect Mac OS X version
        if(preg_match('/applewebkit\/([0-9\.]+).*safari\/([0-9\.]+).*/si', $user_agent, $tmp_array))
          {
          if($tmp_array[1] == "418.8")
            {
            $k_detected['os'] .= " 10.4.7";
            }
          elseif(substr($tmp_array[1], 0, 3) == "418")
            {
            $k_detected['os'] .= " 10.4.6";
            }
          elseif($tmp_array[1] == "417.9")
            {
            $k_detected['os'] .= " 10.4.4/10.4.5";
            }
          elseif(substr($tmp_array[1], 0, 3) == "416")
            {
            $k_detected['os'] .= " 10.4.3";
            }
          elseif(substr($tmp_array[1], 0, 4) == "412.")
            {
            $k_detected['os'] .= " 10.4.2";
            }
          elseif(substr($tmp_array[1], 0, 3) == "412")
            {
            $k_detected['os'] .= " 10.4/10.4.1";
            }
          elseif(substr($tmp_array[1], 0, 3) == "312")
            {
            $k_detected['os'] .= " 10.3.9";
            }
          elseif($tmp_array[1] == "125.5.7")
            {
            $k_detected['os'] .= " 10.3.8";
            }
          elseif($tmp_array[1] == "125.5.5" && $tmp_array[2] == "125.11")
            {
            $k_detected['os'] .= " 10.3.6";
            }
          elseif(($tmp_array[1] == "125.5.6" || $tmp_array[1] == "125.5.5") && substr($tmp_array[1], 0, 5) == "125.1")
            {
            $k_detected['os'] .= " 10.3.6/10.3.7/10.3.8";
            }
          elseif($tmp_array[1] == "125.5" || $tmp_array[1] == "125.4")
            {
            $k_detected['os'] .= " 10.3.5";
            }
          elseif($tmp_array[1] == "125.2")
            {
            $k_detected['os'] .= " 10.3.4";
            }
          elseif($tmp_array[1] == "100"  && $tmp_array[2] == "100.1")
            {
            $k_detected['os'] .= " 10.3.2";
            }
          elseif(substr($tmp_array[1], 0, 3) == "100")
            {
            $k_detected['os'] .= " 10.3";
            }
          elseif(substr($tmp_array[1], 0, 2) == "85")
            {
            $k_detected['os'] .= " 10.2.8";
            }
          }
        }
      }

    // SunOs
    if(preg_match('/sunos/si', $user_agent) && !$k_detected['os'])
      {
      $k_detected['os'] = "Solaris";
      $k_detected['os_ico'] = "solaris";
      }

    // Amiga
    if(preg_match('/amiga/si', $user_agent) && !$k_detected['os'])
      {
      $k_detected['os'] = "Amiga";
      $k_detected['os_ico'] = "amiga";
      }

    // Irix
    if(preg_match('/irix/si', $user_agent) && !$k_detected['os'])
      {
      $k_detected['os'] = "IRIX";
      $k_detected['os_ico'] = "irix";
      }

    // OpenVMS
    if(preg_match('/open.*vms/si', $user_agent) && !$k_detected['os'])
      {
      $k_detected['os'] = "OpenVMS";
      $k_detected['os_ico'] = "openvms";
      }

    // BeOs
    if(preg_match('/beos/si', $user_agent) && !$k_detected['os'])
      {
      $k_detected['os'] = "BeOS";
      $k_detected['os_ico'] = "beos";
      }

    // Java on mobile
    if(preg_match('/j2me/si', $user_agent) && !$k_detected['os'])
      {
      $k_detected['os'] = "Java Platform Micro Edition";
      $k_detected['os_ico'] = "java";
      }

    // Symbian Os
    if(preg_match('/symbian/si', $user_agent) && !$k_detected['os'])
      {
      $k_detected['os'] = "Symbian OS";
      $k_detected['os_ico'] = "symbian";
      // try to get version
      if(preg_match('/SymbianOS\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array))
        {
	$k_detected['os'] .= ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Palm Os
    if(preg_match('/palmos/si', $user_agent) && !$k_detected['os'])
      {
      $k_detected['os'] = "Palm OS";
      $k_detected['os_ico'] = "palmos";
      // try to get version
      if(preg_match('/PalmOS ([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array))
        {
	$k_detected['os'] .= ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // PlayStation Portable
    if(preg_match('/psp.*playstation.*portable/si', $user_agent) && !$k_detected['os'])
      {
      $k_detected['os'] = "PlayStation Portable";
      $k_detected['os_ico'] = 'playstation';
      }

    // Try to detect some mobile devices...

    // Nokia
    if(preg_match('/Nokia[ ]{0,1}([0-9a-zA-Z\+\-\.]+){0,1}.*/s', $user_agent, $tmp_array))
      {
      if(!$k_detected['os'])
        {
	$k_detected['os'] = "Nokia" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	$k_detected['os_ico'] = "mobile";
	}
      else
        {
	$k_detected['os'] .= " / Nokia" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Motorola
    if(preg_match('/mot\-([0-9a-zA-Z\+\-\.]+){0,1}\//si', $user_agent, $tmp_array))
      {
      if(!$k_detected['os'])
        {
	$k_detected['os'] = "Motorola" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	$k_detected['os_ico'] = "mobile";
	}
      else
        {
	$k_detected['os'] .= " / Motorola" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Siemens
    if(preg_match('/sie\-([0-9a-zA-Z\+\-\.]+){0,1}\//si', $user_agent, $tmp_array))
      {
      if(!$k_detected['os'])
        {
	$k_detected['os'] = "Siemens" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	$k_detected['os_ico'] = "mobile";
	}
      else
        {
	$k_detected['os'] .= " / Siemens" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Samsung
    if(preg_match('/samsung\-([0-9a-zA-Z\+\-\.]+){0,1}\//si', $user_agent, $tmp_array))
      {
      if(!$k_detected['os'])
        {
	$k_detected['os'] = "Samsung" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	$k_detected['os_ico'] = "mobile";
	}
      else
        {
	$k_detected['os'] .= " / Samsung" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }
    
    // SonyEricsson & Ericsson
    if(preg_match('/SonyEricsson[ ]{0,1}([0-9a-zA-Z\+\-\.]+){0,1}.*/s', $user_agent, $tmp_array))
      {
      if(!$k_detected['os'])
        {
	$k_detected['os'] = "Sony Ericsson" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	$k_detected['os_ico'] = "mobile";
	}
      else
        {
	$k_detected['os'] .= " / Sony Ericsson" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }
    elseif(preg_match('/Ericsson[ ]{0,1}([0-9a-zA-Z\+\-\.]+){0,1}.*/s', $user_agent, $tmp_array))
      {
      if(!$k_detected['os'])
        {
	$k_detected['os'] = "Ericsson" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	$k_detected['os_ico'] = "mobile";
	}
      else
        {
	$k_detected['os'] .= " / Ericsson" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Alcatel
    if(preg_match('/Alcatel\-([0-9a-zA-Z\+\-\.]+){0,1}.*/s', $user_agent, $tmp_array))
      {
      if(!$k_detected['os'])
        {
	$k_detected['os'] = "Alcatel" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	$k_detected['os_ico'] = "mobile";
	}
      else
        {
	$k_detected['os'] .= " / Alcatel" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Panasonic
    if(preg_match('/Panasonic\-{0,1}([0-9a-zA-Z\+\-\.]+){0,1}.*/s', $user_agent, $tmp_array))
      {
      if(!$k_detected['os'])
        {
	$k_detected['os'] = "Panasonic" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	$k_detected['os_ico'] = "mobile";
	}
      else
        {
	$k_detected['os'] .= " / Panasonic" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Philips
    if(preg_match('/Philips\-([0-9a-z\+\-\@\.]+){0,1}.*/si', $user_agent, $tmp_array))
      {
      if(!$k_detected['os'])
        {
	$k_detected['os'] = "Philips" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	$k_detected['os_ico'] = "mobile";
	}
      else
        {
	$k_detected['os'] .= " / Philips" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Acer
    if(preg_match('/Acer\-([0-9a-z\+\-\.]+){0,1}.*/si', $user_agent, $tmp_array))
      {
      if(!$k_detected['os'])
        {
	$k_detected['os'] = "Acer" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	$k_detected['os_ico'] = "mobile";
	}
      else
        {
	$k_detected['os'] .= " / Acer" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // BlackBerry
    if(preg_match('/BlackBerry([0-9a-zA-Z\+\-\.]+){0,1}\//s', $user_agent, $tmp_array))
      {
      if(!$k_detected['os'])
        {
	$k_detected['os'] = "BlackBerry" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	$k_detected['os_ico'] = "mobile";
	}
      else
        {
	$k_detected['os'] .= " / BlackBerry" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Windows 3.x, 95, 98 and other numerical
    if(preg_match('/windows ([0-9\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['os'])
      {
      $k_detected['os'] = "Windows" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      $k_detected['os_ico'] = "win_old";
      }

    if(preg_match('/[ \(]win([0-9\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['os'])
      {
      if($tmp_array[1] == "16")
        {
        $k_detected['os'] = "Windows 3.x";
        $k_detected['os_ico'] = "win_old";
        }
      elseif($tmp_array[1] == "32")
        {
        $k_detected['os'] = "Windows";
        $k_detected['os_ico'] = "win_old";
        }
      else
        {
        $k_detected['os'] = "Windows" . ($tmp_array[1] ? " " . $tmp_array[1] : "");
        $k_detected['os_ico'] = "win_old";
        }
      }

    // Windows ME
    if(preg_match('/windows me/si', $user_agent, $tmp_array) || preg_match('/win 9x 4\.90/si', $user_agent, $tmp_array) && !$k_detected['os'])
      {
      $k_detected['os'] = "Windows Millenium";
      $k_detected['os_ico'] = "win_old";
      }

    // Windows CE
    if(preg_match('/windows ce/si', $user_agent, $tmp_array) && !$k_detected['os'])
      {
      $k_detected['os'] = "Windows CE";
      $k_detected['os_ico'] = "win_old";
      }

    // Windows XP
    if(preg_match('/windows xp/si', $user_agent, $tmp_array) && !$k_detected['os'])
      {
      $k_detected['os'] = "Windows XP";
      $k_detected['os_ico'] = "win_new";
      }

    // Windows NT, no version, to be sure it will catch
    if(preg_match('/windows nt/si', $user_agent, $tmp_array) || preg_match('/winnt/si', $user_agent, $tmp_array) && !$k_detected['os'])
      {
      $k_detected['os'] = "Windows NT";
      $k_detected['os_ico'] = "win_old";
      }

    // Windows NT with version
    if(preg_match('/windows nt ([0-9\.]+).*/si', $user_agent, $tmp_array) || preg_match('/winnt([0-9\.]+).*/si', $user_agent, $tmp_array) && !$k_detected['os'])
      {
      if($tmp_array[1] == "6.0")
        {
        $k_detected['os'] = "Windows Vista";
        $k_detected['os_ico'] = "win_new";
        }
      elseif($tmp_array[1] == "5.2")
        {
        $k_detected['os'] = "Windows Server 2003";
        $k_detected['os_ico'] = "win_new";
        }
      elseif($tmp_array[1] == "5.1")
        {
        $k_detected['os'] = "Windows XP";
        $k_detected['os_ico'] = "win_new";
        }
      elseif($tmp_array[1] == "5.0" || $tmp_array[1] == "5.01")
        {
        $k_detected['os'] = "Windows 2000";
        $k_detected['os_ico'] = "win_old";
        }
      else
        {
        $k_detected['os'] = "Windows NT" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
        $k_detected['os_ico'] = "win_old";
        }
      }

    // Catchall for all other windozez
    if(preg_match('/windows/si', $user_agent, $tmp_array) && !$k_detected['os'])
      {
      $k_detected['os'] = "Windows";
      $k_detected['os_ico'] = "win_old";
      }

    return $k_detected;
}
?>
